PROJECT     = qtella
TRANSLATIONS    = qtella_de.ts \
					qtella_pt_BR.ts \
					qtella_sv.ts \
					qtella_fi.ts \
					qtella_nb.ts \
					qtella_no.ts
TARGET		= qtella
TEMPLATE	= app
LANGUAGE	= C++

CONFIG	+= qt warn_on release thread

DEFINES	+= QT=1, VERSION=\"0.5.4\", ADDITIONAL_VERSION_STR=\"unix\", PIXMAP_DIR=\".\"
INCLUDEPATH	+= ./include ./ui

HEADERS	+= config.h \
	include/AddApplication.h \
	include/Address.h \
	include/AudioFile.h \
	include/AudioGenre.h \
	include/AudioMp3.h \
	include/AudioOgg.h \
	include/AudioUnknown.h \
	include/AudioWav.h \
	include/BAddApplication.h \
	include/BAudioFile.h \
	include/BBlockHost.h \
	include/BDeleteDialog.h \
	include/BDownloadTo.h \
	include/BInterruptedFileSearch.h \
	include/BRenameFile.h \
	include/BResumeHost.h \
	include/BSearchDialog.h \
	include/BSearchWidget.h \
	include/BlockHost.h \
	include/Bye.h \
	include/Connections.h \
	include/DeleteDialog.h \
	include/Download.h \
	include/DownloadManager.h \
	include/DownloadTo.h \
	include/DownloadViewItem.h \
	include/Errors.h \
	include/Gnutella.h \
	include/HashTable.h \
	include/Host.h \
	include/HostCache.h \
	include/HostCacheConnection.h \
	include/Icon.h \
	include/IconTabBar.h \
	include/IconTabDialog.h \
	include/IconTabWidget.h \
	include/InConnection.h \
	include/IncomingConnect.h \
	include/Info.h \
	include/Interface.h \
	include/InterruptedDownloads.h \
	include/InterruptedFile.h \
	include/InterruptedFileSearch.h \
	include/InterruptedViewItem.h \
	include/Logging.h \
	include/Message.h \
	include/Ping.h \
	include/Pong.h \
	include/PongCache.h \
	include/Push.h \
	include/Qtella.h \
	include/QtellaSub.h \
	include/Query.h \
	include/QueryHit.h \
	include/QueryHitEntry.h \
	include/QueryResult.h \
	include/RenameFile.h \
	include/ResumeHost.h \
	include/RiffFile.h \
	include/Search.h \
	include/SearchDialog.h \
	include/SearchSharedFiles.h \
	include/SearchViewItem.h \
	include/SearchWidget.h \
	include/Servent.h \
	include/SharedFile.h \
	include/SharedViewItem.h \
	include/Statistic.h \
	include/StringManipulation.h \
	include/Upload.h \
	include/UploadManager.h \
	include/qtella_mini_xpm.h
SOURCES	+= src/AddApplication.cpp \
	src/AddApplication_moc.cpp \
	src/Address.cpp \
	src/AudioFile.cpp \
	src/AudioGenre.cpp \
	src/AudioMp3.cpp \
	src/AudioOgg.cpp \
	src/AudioWav.cpp \
	src/BAddApplication.cpp \
	src/BAddApplication_moc.cpp \
	src/BAudioFile.cpp \
	src/BAudioFile_moc.cpp \
	src/BBlockHost.cpp \
	src/BBlockHost_moc.cpp \
	src/BDeleteDialog.cpp \
	src/BDeleteDialog_moc.cpp \
	src/BDownloadTo.cpp \
	src/BDownloadTo_moc.cpp \
	src/BInterruptedFileSearch.cpp \
	src/BInterruptedFileSearch_moc.cpp \
	src/BRenameFile.cpp \
	src/BRenameFile_moc.cpp \
	src/BResumeHost.cpp \
	src/BResumeHost_moc.cpp \
	src/BSearchDialog.cpp \
	src/BSearchDialog_moc.cpp \
	src/BSearchWidget.cpp \
	src/BSearchWidget_moc.cpp \
	src/BlockHost.cpp \
	src/BlockHost_moc.cpp \
	src/Bye.cpp \
	src/Connections.cpp \
	src/Connections_moc.cpp \
	src/DeleteDialog.cpp \
	src/DeleteDialog_moc.cpp \
	src/Download.cpp \
	src/DownloadManager.cpp \
	src/DownloadManager_moc.cpp \
	src/DownloadTo.cpp \
	src/DownloadTo_moc.cpp \
	src/DownloadViewItem.cpp \
	src/Download_moc.cpp \
	src/HashTable.cpp \
	src/Host.cpp \
	src/HostCache.cpp \
	src/HostCacheConnection.cpp \
	src/Icon.cpp \
	src/IconTabBar.cpp \
	src/IconTabBar_moc.cpp \
	src/IconTabDialog.cpp \
	src/IconTabDialog_moc.cpp \
	src/IconTabWidget.cpp \
	src/IconTabWidget_moc.cpp \
	src/InConnection.cpp \
	src/InConnection_moc.cpp \
	src/IncomingConnect.cpp \
	src/IncomingConnect_moc.cpp \
	src/Info.cpp \
	src/Info_moc.cpp \
	src/Interface.cpp \
	src/InterruptedDownloads.cpp \
	src/InterruptedDownloads_moc.cpp \
	src/InterruptedFile.cpp \
	src/InterruptedFileSearch.cpp \
	src/InterruptedFileSearch_moc.cpp \
	src/InterruptedViewItem.cpp \
	src/Logging.cpp \
	src/Message.cpp \
	src/Ping.cpp \
	src/Pong.cpp \
	src/PongCache.cpp \
	src/PongCache_moc.cpp \
	src/Push.cpp \
	src/Qtella.cpp \
	src/QtellaSub.cpp \
	src/QtellaSubConfig.cpp \
	src/QtellaSubSlots.cpp \
	src/QtellaSubSlotsContext.cpp \
	src/QtellaSubSlotsMenu.cpp \
	src/QtellaSub_moc.cpp \
	src/Qtella_moc.cpp \
	src/Query.cpp \
	src/QueryHit.cpp \
	src/QueryHitEntry.cpp \
	src/QueryResult.cpp \
	src/RenameFile.cpp \
	src/RenameFile_moc.cpp \
	src/ResumeHost.cpp \
	src/ResumeHost_moc.cpp \
	src/RiffFile.cpp \
	src/Search.cpp \
	src/SearchDialog.cpp \
	src/SearchDialog_moc.cpp \
	src/SearchSharedFiles.cpp \
	src/SearchViewItem.cpp \
	src/SearchWidget.cpp \
	src/SearchWidget_moc.cpp \
	src/Servent.cpp \
	src/Servent_moc.cpp \
	src/SharedFile.cpp \
	src/SharedViewItem.cpp \
	src/Statistic.cpp \
	src/StringManipulation.cpp \
	src/Upload.cpp \
	src/UploadManager.cpp \
	src/UploadManager_moc.cpp \
	src/Upload_moc.cpp \
	src/main.cpp
FORMS	= ui/BAddApplication.ui \
	ui/BAudioFile.ui \
	ui/BBlockHost.ui \
	ui/BDeleteDialog.ui \
	ui/BDownloadTo.ui \
	ui/BInterruptedFileSearch.ui \
	ui/BRenameFile.ui \
	ui/BResumeHost.ui \
	ui/BSearchDialog.ui \
	ui/BSearchWidget.ui \
	ui/Info.ui \
	ui/Qtella.ui \
	ui/Qtella.ui.bak.ui \
	ui/Qtella_mini.ui \
	ui/sharp/BAddApplication.ui \
	ui/sharp/BAudioFile.ui \
	ui/sharp/BBlockHost.ui \
	ui/sharp/BDeleteDialog.ui \
	ui/sharp/BDownloadTo.ui \
	ui/sharp/BInterruptedFileSearch.ui \
	ui/sharp/BRenameFile.ui \
	ui/sharp/BResumeHost.ui \
	ui/sharp/BSearchDialog.ui \
	ui/sharp/BSearchWidget.ui \
	ui/sharp/Info.ui \
	ui/sharp/Qtella.ui \
	ui/BBrowser.ui

