#include "DownloadViewItem.h"

#include <qstring.h>
#include <qobject.h>

DownloadViewItem::DownloadViewItem(QListView *parent) 
  : QListViewItem(parent)
{
}


DownloadViewItem::DownloadViewItem(QListViewItem *parent) 
  : QListViewItem(parent)
{
}

int DownloadViewItem::compare( QListViewItem* item, int column, bool ascending ) const
{
	if( ! item )
		return 0;
	DownloadViewItem* i = ( DownloadViewItem* ) item;
	QString status;
	QString status1;

	switch( column ) {
		case 0: // sort by filename
			return text( 0 ).lower().compare( i->text( 0 ).lower() );
		case 1: // sort by status
			if( text( 1 ).contains( QObject::tr( "Completed" ) ) ) 
				status = "A";
			else if( text( 1 ).contains( QObject::tr( "Connected" ) ) ) 
				status = "B";
			else if( text( 1 ).contains( QObject::tr( "Connecting" ) ) ) 
				status = "C";
			else if( text( 1 ).contains( QObject::tr( "Push" ) ) ) 
				status = "D";
			else if( text( 1 ).contains( QObject::tr( "Queue" ) ) ) 
				status = "E";
			else if( text( 1 ).contains( QObject::tr( "Close" ) ) ) 
				status = "F";
			else if( text( 1 ).contains( QObject::tr( "Busy" ) ) ) 
				status = "G";
			else if( text( 1 ).contains( QObject::tr( "Time" ) ) ) 
				status = "H";
			else if( text( 1 ).contains( QObject::tr( "Error" ) ) ) 
				status = "I";
			else if( text( 1 ).contains( QObject::tr( "Abort" ) ) ) 
				status = "J";
			else if( text( 1 ).contains( QObject::tr( "Exist" ) ) ) 
				status1 = "K";
			if( i->text( 1 ).contains( QObject::tr( "Completed" ) ) ) 
				status = "A";
			else if( i->text( 1 ).contains( QObject::tr( "Connected" ) ) ) 
				status1 = "B";
			else if( i->text( 1 ).contains( QObject::tr( "Connecting" ) ) ) 
				status1 = "C";
			else if( i->text( 1 ).contains( QObject::tr( "Push" ) ) ) 
				status1 = "D";
			else if( i->text( 1 ).contains( QObject::tr( "Queue" ) ) ) 
				status1 = "E";
			else if( i->text( 1 ).contains( QObject::tr( "Close" ) ) ) 
				status1 = "F";
			else if( i->text( 1 ).contains( QObject::tr( "Busy" ) ) ) 
				status1 = "G";
			else if( i->text( 1 ).contains( QObject::tr( "Time" ) ) ) 
				status1 = "H";
			else if( i->text( 1 ).contains( QObject::tr( "Error" ) ) ) 
				status1 = "I";
			else if( i->text( 1 ).contains( QObject::tr( "Abort" ) ) ) 
				status1 = "J";
			else if( i->text( 1 ).contains( QObject::tr( "Exist" ) ) ) 
				status1 = "K";
			return status.compare( status1 );
		case 2:  // filesize
			return text( 2 ).rightJustify( 15, '0' ).compare( i->text( 2 ).rightJustify( 15, '0' ) );
		case 3:  // progress
			return text( 3 ).rightJustify( 6, '0' ).compare( i->text( 3 ).rightJustify( 15, '0' ) );
		case 4:  // host
			return text( 4 ).compare( i->text( 4 ) );
		case 5:  // bandwidth
			return text( 5 ).rightJustify( 11, '0' ).compare( i->text( 5 ).rightJustify( 15, '0' ) );
		case 6:  // time
			return text( 6 ).rightJustify( 10, '0' ).compare( i->text( 6 ).rightJustify( 15, '0' ) );
		case 7: // sort by client name
			return text( 7 ).lower().compare( i->text( 7 ).lower() );
	}
	return -1;
}
