#include "HostCacheConnection.h"
#include "HostCache.h"
#include "QtellaSub.h"
#include "Message.h"
#include "Ping.h"
#include "Pong.h"
#include <qfile.h>
#include <qsocketdevice.h>
#include <qdatetime.h>
#include <qlistbox.h>
#include <qcheckbox.h>
#include <qlineedit.h>

#include <string>
#include <vector>
#ifdef _DEBUG
#include <iostream>
#endif

#define TIMEOUT 2

#ifndef SHARP
QMutex HostCacheConnection::_mutex;
#endif

HostCacheConnection::HostCacheConnection(int socket, HostCache* parent, std::list<Pong>& ponglist)
  : _parent(parent), _socket(socket), _ponglist(ponglist)
{
}

void HostCacheConnection::run()
{
// #ifndef SHARP
//   QSocketDevice* s = new QSocketDevice(_socket, QSocketDevice::Stream);

//   if(! ((QtellaSub*)(_parent->_parent))->ui_checkbox_enablehostcache->isChecked() ) 
//     {
//       s->close();
//       delete s;
//       return;
//     }
  
//   std::vector< std::string > connect_strings;
//   connect_strings.push_back(QtellaSub::getInstance()->_gnutella_id + " CONNECT/0.4\n\n" );
//   connect_strings.push_back(QtellaSub::getInstance()->_gnutella_id + " CONNECT/0.6\r\n" );

//   int  timeout = 0;
//   int  header;
//   std::string recv;

//   while( timeout < TIMEOUT * 10 )
//     {
// 	  int bytes_avail = s->bytesAvailable();
// 	  if( bytes_avail > 0 )
// 		{
// 		  char* buffer = new char[bytes_avail];
// 		  s->readBlock( buffer, bytes_avail );
// 		  recv += std::string( buffer, bytes_avail );
// 		  delete buffer;
// 		  for( header = 0; header < connect_strings.size(); ++header )
// 			if( recv.substr( 0, connect_strings[header].size() ) == connect_strings[header] )
// 			  break;
// 		  if( header < connect_strings.size() )
// 			break;
// 		}
// 	  else
// 		{
// 		  msleep(100);
// 		  timeout++;
// 		}
//     }

//   std::string logging;
//   logging += std::string(QDate::currentDate().toString());
//   logging += " " + std::string(QTime::currentTime().toString());
//   logging += " Connection from ";
//   logging += std::string(s->peerAddress().toString());

//   if( header < connect_strings.size() )
//     {
//       if( recv == connect_strings[0] )  // GNUTELLA 0.4
// 		{
// 		  logging += " ok";
//                std::string t (QtellaSub::getInstance()->_gnutella_id);
//                t += " OK\n\n";
//                s->writeBlock(t.data(), t.length());
		  
// 		  timeout = 0;
// 		  while( (s->bytesAvailable() < 23) && (timeout < 200) )
// 			{
// 			  msleep(10);
// 			  timeout++;
// 			}
		  
// 		  if(timeout < 100)
// 			{
// 			  char buffer[50];
// 			  logging += " ok";
// 			  s->readBlock(buffer, 23);
			  
// 			  std::string     msg(buffer, 23);
// 			  Message         m(msg);
// 			  Ping*           p = m.getPing();
			  
// 			  std::list<Pong>::iterator     pos;
			  
// 			  for( pos = _ponglist.begin(); pos != _ponglist.end(); ++pos)
// 				{
// 				  pos->_id = p->_id;
// 				  s->writeBlock( (*pos)._data.c_str(), (*pos)._data.size() );
// 				}
			  
// 			  s->flush();
// 			  this->msleep(1500);
// 			  s->close();
			  
// 			  delete p;
// 			}
// 		  else
// 			logging += " timeout";
// 		} // GNUTELLA 0.4
//       else
// 		if( recv.substr( 0, connect_strings[1].size() ) == connect_strings[1] ) // GNUTELLA 0.6
// 		  {
// 			logging += " ok";
//                      std::string str = QtellaSub::getInstance()->_gnutella_id
//                        + "/0.6 403 Forbidden\r\nUser-Agent: Qtella " + std::string(VERSION)
// 			  + ADDITIONAL_VERSION_STR + "\r\nX-Try: ";

// 			std::list<Pong>::iterator     pos;
// 			while( _ponglist.size() > 20 )
// 			  _ponglist.pop_front();
// 			for( pos = _ponglist.begin(); pos != _ponglist.end(); ++pos)
// 			  str += pos->_address.toString() + ",";
// 			if( ! _ponglist.empty() ) // delete last ","
// 			  str.erase( str.size() - 1 );
// 			str += "\r\n\r\n";
// #ifdef _DEBUG
// 			std::cout << "send: " << str << "----" << std::endl;
// #endif
// 			s->flush();
// 			this->msleep(1500);
// 			s->close();
			  
// 			s->writeBlock( str.data(), str.size() );
// 		  } // GNUTELLA 0.6
// 		else
// 		  logging += " unkown protocol"; // <" + recv + ">";
//     }
//   else
//     logging += " timeout"; // <" + recv + ">";
  
//   _mutex.lock();

//   QListBox* l = ((QtellaSub*)(_parent->_parent))->ui_listbox_hostcachelogging;

//   if( ((QtellaSub*)(_parent->_parent))->ui_checkbox_enablelogging->isChecked() )
//     {
//       if( l->count() > 200 ) l->removeItem(0);

//       l->insertItem(logging.c_str());
//       l->setBottomItem(l->count()-1);

//       if(! std::string( ((QtellaSub*)(_parent->_parent))->ui_lineedit_hostcachelogfile->text() ).empty() )
//         {
//           QFile logfile( ((QtellaSub*)(_parent->_parent))->ui_lineedit_hostcachelogfile->text() );
//           if(logfile.open(IO_Raw|IO_Append|IO_ReadWrite))
//             {
//               logfile.writeBlock( (logging+"\n").c_str(), logging.size()+1 );
//               logfile.close();
//             }
//         }
//     }
  
//   _mutex.unlock();
  
//   delete s;
// #endif
}
