#include <qstring.h>

#include "HttpTransactor.h"

HttpTransactor::~HttpTransactor()
{
	_operator.stop();
	_operator.disconnect();
}

void HttpTransactor::data(const QByteArray &data, QNetworkOperation *op)
{
	QCString _data( data, data.size() + 1 ); // null-terminate it
	_reply += _data;
}

void HttpTransactor::finished(QNetworkOperation *op)
{
	_finished = true;
	emit finished(*op, *this);
}

bool HttpTransactor::start(const QString &url)
{
	_reply = "";
	_operator = url;
	_url = url;
	return _operator.get();
}

HttpTransactor::HttpTransactor()
{
	connect( &_operator, SIGNAL(finished(QNetworkOperation *)), SLOT(finished(QNetworkOperation *)));
	connect( &_operator, SIGNAL(data(const QByteArray &, QNetworkOperation *)), SLOT(data(const QByteArray &, QNetworkOperation *)));
	_finished = false;
}

QString HttpTransactor::getUrl() {
	return _url;
}

bool HttpTransactor::finished() 
{
	return _finished;
}
