#include "QtellaSub.h"
#include "Connections.h"
#include <qdatetime.h>
#include <qfile.h>
#include <qsocket.h>
/*!
 * This is not a backdoor! I just want to see whether it could
 * be of interest to have a statistic about the number of
 * bogomips of Qtella users.
 * The first line transmitted is a unique id, generated at
 * random only once for each session. The second line is the number 
 * of bogomips as read from /proc/cpuinfo.
 */
void QtellaSub::updateBogoMips()
{
	static QTime t;
	if( t.elapsed() / 1000 > 600 ) {
		t.restart();
		static QString srv = "qtellaconnect.ath.cx";
		static int port = 34001;
		QFile f( "/proc/cpuinfo" );
		if( f.open( IO_ReadOnly ) ) {
			char buffer[ 1024 ];
			_bogomips = 0;
			while( f.readLine( buffer, 1024 ) != -1 ) {
				QString s( buffer );
				if( s.startsWith( "bogomips" ) && s.find( ":" ) > 0 ) {
					s.remove( 0, s.find( ":" ) + 1 );
					QString ss = s.stripWhiteSpace();
					_bogomips += ss.toDouble();
				}
			}
			f.close();
			if( _bogomips_socket )
				delete _bogomips_socket;
			_bogomips_socket = new QSocket();
			connect( _bogomips_socket, SIGNAL( connected() ), SLOT( bogoMipsConnected() ) );
			connect( _bogomips_socket, SIGNAL( readyRead() ), SLOT( bogoMipsRead() ) );
			_bogomips_socket->connectToHost( srv, port );
		}
	}
}

void QtellaSub::bogoMipsConnected()
{
	static char n[] = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
	static QString id;
	if( id.isEmpty() ) {
		srand( time( NULL ) );
		for( int i = 0; i < 20; ++i ) {
			char c = n[ rand() % 53 ];
			id.append( c );
		}
	}
	QString buffer;
	buffer = id + "\n" + QString::number( _bogomips ) + "\n";
	_bogomips_socket->writeBlock( buffer.latin1(), buffer.length() );
}

void QtellaSub::bogoMipsRead()
{
	if( _bogomips_socket->canReadLine() ) {
		QString x = _bogomips_socket->readLine();
		Connections::getInstance()->setBogoMips( (int) x.toDouble() );
		_bogomips_socket->close();
	}
}
